Package org.optaplanner.core.impl.score.director.drools

## Class DroolsScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>

- java.lang.Object
- - org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory<Solution_,​Score_>
  - - org.optaplanner.core.impl.score.director.drools.DroolsScoreDirectorFactory<Solution_,​Score_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
    `Score_` - the score type to go with the solution
  All Implemented Interfaces:
    `InnerScoreDirectorFactory<Solution_,​Score_>`, `ScoreDirectorFactory<Solution_>`
  Direct Known Subclasses:
    `TestGenDroolsScoreDirectorFactory`

      public class DroolsScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>
      extends AbstractScoreDirectorFactory<Solution_,​Score_>

  Drools implementation of `ScoreDirectorFactory`.
  See Also:
    `DroolsScoreDirector`, `ScoreDirectorFactory`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Map<org.kie.api.definition.rule.Rule,​Function<Solution_,​Score_>>` | `ruleToConstraintWeightExtractorMap` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertClonedSolution, assertionScoreDirectorFactory, initializingScoreTrend, logger, solutionDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor, org.kie.api.KieBase kieBase)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DroolsScoreDirector<Solution_,​Score_>` | `buildScoreDirector​(boolean lookUpEnabled, boolean constraintMatchEnabledPreference)` | Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
    `protected void` | `checkIfGlobalScoreHolderExists​(org.kie.api.KieBase kieBase)` |
    `protected void` | `createRuleToConstraintWeightExtractorMap​(org.kie.api.KieBase kieBase)` |
    `Map<org.kie.api.definition.rule.Rule,​Function<Solution_,​Score_>>` | `getRuleToConstraintWeightExtractorMap()` |
    `org.kie.api.runtime.KieSession` | `newKieSession()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertScoreFromScratch, buildScoreDirector, getAssertionScoreDirectorFactory, getInitializingScoreTrend, getScoreDefinition, getSolutionDescriptor, isAssertClonedSolution, setAssertClonedSolution, setAssertionScoreDirectorFactory, setInitializingScoreTrend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ruleToConstraintWeightExtractorMap

          protected Map<org.kie.api.definition.rule.Rule,​Function<Solution_,​Score_ extends Score<Score_>>> ruleToConstraintWeightExtractorMap

  - ### Constructor Detail

    - #### DroolsScoreDirectorFactory

          public DroolsScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor,
                                            org.kie.api.KieBase kieBase)

      Parameters:
        `solutionDescriptor` - never null
        `kieBase` - never null

  - ### Method Detail

    - #### checkIfGlobalScoreHolderExists

          protected void checkIfGlobalScoreHolderExists​(org.kie.api.KieBase kieBase)

    - #### createRuleToConstraintWeightExtractorMap

          protected void createRuleToConstraintWeightExtractorMap​(org.kie.api.KieBase kieBase)

    - #### getRuleToConstraintWeightExtractorMap

          public Map<org.kie.api.definition.rule.Rule,​Function<Solution_,​Score_>> getRuleToConstraintWeightExtractorMap()

    - #### buildScoreDirector

          public DroolsScoreDirector<Solution_,​Score_> buildScoreDirector​(boolean lookUpEnabled,
                                                                                boolean constraintMatchEnabledPreference)

      Description copied from interface: `InnerScoreDirectorFactory`
      Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
      Parameters:
        `lookUpEnabled` - true if a `ScoreDirector` implementation should track all working objects for `ScoreDirector.lookUpWorkingObject(Object)`
        `constraintMatchEnabledPreference` - false if a `ScoreDirector` implementation should not do `ConstraintMatch` tracking even if it supports it.
      Returns:
        never null
      See Also:
        `InnerScoreDirector.isConstraintMatchEnabled()`, `InnerScoreDirector.getConstraintMatchTotalMap()`

    - #### newKieSession

          public org.kie.api.runtime.KieSession newKieSession()